"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var HtmlWebpackPlugin = require('html-webpack-plugin');

var HtmlWebpackInjectPlugin = function HtmlWebpackInjectPlugin(config) {
  var _this = this;

  _classCallCheck(this, HtmlWebpackInjectPlugin);

  _defineProperty(this, "apply", function (compiler) {
    compiler.hooks.compilation.tap('HtmlWebpackInjectPlugin', function (compilation) {
      var hooks = HtmlWebpackPlugin.getHooks(compilation).alterAssetTagGroups;
      hooks.tapAsync('HtmlWebpackInjectPlugin', function (htmlPluginData, cb) {
        var tags = htmlPluginData[`${_this.parent}Tags`];
        htmlPluginData[`${_this.parent}Tags`] = _this.prepend ? _this.assets.concat(tags) : tags.concat(_this.assets);
        return cb(null, htmlPluginData);
      });
    });
  });

  var _config$externals = config.externals,
      externals = _config$externals === void 0 ? [] : _config$externals,
      _config$parent = config.parent,
      parent = _config$parent === void 0 ? 'head' : _config$parent,
      _config$prepend = config.prepend,
      prepend = _config$prepend === void 0 ? false : _config$prepend;
  this.assets = externals.map(function (_ref) {
    var _ref$tag = _ref.tag,
        tag = _ref$tag === void 0 ? 'meta' : _ref$tag,
        _ref$attrs = _ref.attrs,
        attrs = _ref$attrs === void 0 ? {} : _ref$attrs;
    return {
      tagName: tag,
      attributes: attrs,
      closeTag: true
    };
  });

  if (parent !== 'head' && parent !== 'body') {
    throw new TypeError('parent should be one of `head` or `body`');
  }

  this.parent = parent;
  this.prepend = prepend;
};

exports.default = HtmlWebpackInjectPlugin;